--- openoffice.org-2.0.2/xmlsecurity/source/helper/xsecparser.cxx	2005-09-09 19:23:32.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/helper/xsecparser.cxx	2006-04-07 13:57:23.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: xsecparser.cxx,v $
  *
- *  $Revision: 1.4 $
+ *  $Revision: 1.5 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:23:32 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:57:23 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -38,6 +38,7 @@
 #ifndef _TOOLS_DEBUG_HXX //autogen wg. DBG_ASSERT
 #include <tools/debug.hxx>
 #endif
+#include "cppuhelper/exc_hlp.hxx"
 
 namespace cssu = com::sun::star::uno;
 namespace cssxs = com::sun::star::xml::sax;
@@ -101,172 +102,206 @@
 	const cssu::Reference< cssxs::XAttributeList >& xAttribs )
 	throw (cssxs::SAXException, cssu::RuntimeException)
 {
-	rtl::OUString ouIdAttr = getIdAttr(xAttribs);
-	if (ouIdAttr != NULL)
+	try
 	{
-		m_pXSecController->collectToVerify( ouIdAttr );
-	}
-	
-	if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATURE)) )
-	{
-		m_pXSecController->addSignature();
+		rtl::OUString ouIdAttr = getIdAttr(xAttribs);
 		if (ouIdAttr != NULL)
 		{
-			m_pXSecController->setId( ouIdAttr );
+			m_pXSecController->collectToVerify( ouIdAttr );
 		}
-	}
-	else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_REFERENCE)) )
-	{
-		rtl::OUString ouUri = xAttribs->getValueByName(rtl::OUString(RTL_ASCII_USTRINGPARAM(ATTR_URI)));
-		DBG_ASSERT( ouUri != NULL, "URI == NULL" );
 		
-		if (0 == ouUri.compareTo(rtl::OUString(RTL_ASCII_USTRINGPARAM(CHAR_FRAGMENT)),1))
+		if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATURE)) )
 		{
-			/*
-			 * remove the first character '#' from the attribute value
-			 */
-			m_pXSecController->addReference( ouUri.copy(1) );
+			m_pXSecController->addSignature();
+			if (ouIdAttr != NULL)
+			{
+				m_pXSecController->setId( ouIdAttr );
+			}
 		}
-		else
+		else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_REFERENCE)) )
 		{
-			/*
-			 * remember the uri
-			 */
-			m_currentReferenceURI = ouUri;
-			m_bReferenceUnresolved = true;
+			rtl::OUString ouUri = xAttribs->getValueByName(rtl::OUString(RTL_ASCII_USTRINGPARAM(ATTR_URI)));
+			DBG_ASSERT( ouUri != NULL, "URI == NULL" );
+			
+			if (0 == ouUri.compareTo(rtl::OUString(RTL_ASCII_USTRINGPARAM(CHAR_FRAGMENT)),1))
+			{
+				/*
+				* remove the first character '#' from the attribute value
+				*/
+				m_pXSecController->addReference( ouUri.copy(1) );
+			}
+			else
+			{
+				/*
+				* remember the uri
+				*/
+				m_currentReferenceURI = ouUri;
+				m_bReferenceUnresolved = true;
+			}
 		}
-	}
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_TRANSFORM)))
-        {
-		if ( m_bReferenceUnresolved )
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_TRANSFORM)))
+			{
+			if ( m_bReferenceUnresolved )
+			{
+				rtl::OUString ouAlgorithm = xAttribs->getValueByName(rtl::OUString(RTL_ASCII_USTRINGPARAM(ATTR_ALGORITHM)));
+				
+				if (ouAlgorithm != NULL && ouAlgorithm == rtl::OUString(RTL_ASCII_USTRINGPARAM(ALGO_C14N)))
+				/*
+				* a xml stream
+				*/
+				{
+					m_pXSecController->addStreamReference( m_currentReferenceURI, sal_False);
+					m_bReferenceUnresolved = false;
+				}
+			}
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509ISSUERNAME)))
+			{
+			m_ouX509IssuerName = rtl::OUString::createFromAscii("");
+			m_bInX509IssuerName = true;
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509SERIALNUMBER)))
+			{
+			m_ouX509SerialNumber = rtl::OUString::createFromAscii("");
+			m_bInX509SerialNumber = true;
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509CERTIFICATE)))
+			{
+			m_ouX509Certificate = rtl::OUString::createFromAscii("");
+			m_bInX509Certificate = true;
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATUREVALUE)))
+			{
+			m_ouSignatureValue = rtl::OUString::createFromAscii("");
+        		m_bInSignatureValue = true;
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_DIGESTVALUE)))
+			{
+			m_ouDigestValue = rtl::OUString::createFromAscii("");
+        		m_bInDigestValue = true;
+			}
+			else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATUREPROPERTY)) )
 		{
-			rtl::OUString ouAlgorithm = xAttribs->getValueByName(rtl::OUString(RTL_ASCII_USTRINGPARAM(ATTR_ALGORITHM)));
-			
-			if (ouAlgorithm != NULL && ouAlgorithm == rtl::OUString(RTL_ASCII_USTRINGPARAM(ALGO_C14N)))
-			/*
-			 * a xml stream
-			 */
+			if (ouIdAttr != NULL)
 			{
-				m_pXSecController->addStreamReference( m_currentReferenceURI, sal_False);
-				m_bReferenceUnresolved = false;
+				m_pXSecController->setPropertyId( ouIdAttr );
 			}
 		}
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509ISSUERNAME)))
-        {
-		m_ouX509IssuerName = rtl::OUString::createFromAscii("");
-		m_bInX509IssuerName = true;
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509SERIALNUMBER)))
-        {
-		m_ouX509SerialNumber = rtl::OUString::createFromAscii("");
-		m_bInX509SerialNumber = true;
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509CERTIFICATE)))
-        {
-		m_ouX509Certificate = rtl::OUString::createFromAscii("");
-		m_bInX509Certificate = true;
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATUREVALUE)))
-        {
-		m_ouSignatureValue = rtl::OUString::createFromAscii("");
-        	m_bInSignatureValue = true;
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_DIGESTVALUE)))
-        {
-		m_ouDigestValue = rtl::OUString::createFromAscii("");
-        	m_bInDigestValue = true;
-        }
-        else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATUREPROPERTY)) )
-	{
-		if (ouIdAttr != NULL)
+			else if (aName == rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(NSTAG_DC))
+        				+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(":"))
+        				+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(TAG_DATE)))
+			{
+			m_ouDate = rtl::OUString::createFromAscii("");
+        		m_bInDate = true;
+			}
+			/*
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_TIME)))
+			{
+			m_ouTime = rtl::OUString::createFromAscii("");
+        		m_bInTime = true;
+			}
+			*/
+			
+		if (m_xNextHandler.is())
 		{
-			m_pXSecController->setPropertyId( ouIdAttr );
+			m_xNextHandler->startElement(aName, xAttribs);
 		}
 	}
-        else if (aName == rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(NSTAG_DC))
-        			+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(":"))
-        			+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(TAG_DATE)))
-        {
-		m_ouDate = rtl::OUString::createFromAscii("");
-        	m_bInDate = true;
-        }
-        /*
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_TIME)))
-        {
-		m_ouTime = rtl::OUString::createFromAscii("");
-        	m_bInTime = true;
-        }
-        */
-		
-	if (m_xNextHandler.is())
-	{
-		m_xNextHandler->startElement(aName, xAttribs);
+	catch (cssu::Exception& )
+	{//getCaughtException MUST be the first line in the catch block
+        cssu::Any exc =  cppu::getCaughtException();
+        throw cssxs::SAXException(
+			rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(
+                              "xmlsecurity: Exception in XSecParser::startElement")),
+            0, exc);
+	}
+	catch (...)
+	{
+		throw cssxs::SAXException(
+			rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("xmlsecurity: unexpected exception in XSecParser::startElement")), 0,
+			cssu::Any());
 	}
 }
 	
 void SAL_CALL XSecParser::endElement( const rtl::OUString& aName ) 
 	throw (cssxs::SAXException, cssu::RuntimeException)
 {
-        if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_DIGESTVALUE)))
-        {
-        	m_bInDigestValue = false;
-        }
-	else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_REFERENCE)) )
+	try 
 	{
-		if ( m_bReferenceUnresolved )
+        if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_DIGESTVALUE)))
+			{
+        		m_bInDigestValue = false;
+			}
+		else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_REFERENCE)) )
+		{
+			if ( m_bReferenceUnresolved )
+			/*
+			* it must be a octet stream
+			*/
+			{
+				m_pXSecController->addStreamReference( m_currentReferenceURI, sal_True);
+				m_bReferenceUnresolved = false;
+			}
+			
+			m_pXSecController->setDigestValue( m_ouDigestValue );
+		}
+		else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNEDINFO)) )
+		{
+			m_pXSecController->setReferenceCount();
+		}
+		else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATUREVALUE)) )
+		{
+			m_pXSecController->setSignatureValue( m_ouSignatureValue );
+        		m_bInSignatureValue = false;
+		}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509ISSUERNAME)))
+			{
+			m_pXSecController->setX509IssuerName( m_ouX509IssuerName );
+			m_bInX509IssuerName = false;
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509SERIALNUMBER)))
+			{
+			m_pXSecController->setX509SerialNumber( m_ouX509SerialNumber );
+			m_bInX509SerialNumber = false;
+			}
+			else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509CERTIFICATE)))
+			{
+			m_pXSecController->setX509Certificate( m_ouX509Certificate );
+			m_bInX509Certificate = false;
+			}
+			else if (aName == rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(NSTAG_DC))
+        				+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(":"))
+        				+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(TAG_DATE)))
+		{
+			m_pXSecController->setDate( m_ouDate );
+        		m_bInDate = false;
+		}
 		/*
-		 * it must be a octet stream
-		 */
+		else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_TIME)) )
 		{
-			m_pXSecController->addStreamReference( m_currentReferenceURI, sal_True);
-			m_bReferenceUnresolved = false;
+			m_pXSecController->setTime( m_ouTime );
+        		m_bInTime = false;
 		}
-		
-		m_pXSecController->setDigestValue( m_ouDigestValue );
-	}
-	else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNEDINFO)) )
-	{
-		m_pXSecController->setReferenceCount();
-	}
-	else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_SIGNATUREVALUE)) )
-	{
-		m_pXSecController->setSignatureValue( m_ouSignatureValue );
-        	m_bInSignatureValue = false;
-	}
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509ISSUERNAME)))
-        {
-		m_pXSecController->setX509IssuerName( m_ouX509IssuerName );
-		m_bInX509IssuerName = false;
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509SERIALNUMBER)))
-        {
-		m_pXSecController->setX509SerialNumber( m_ouX509SerialNumber );
-		m_bInX509SerialNumber = false;
-        }
-        else if (aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_X509CERTIFICATE)))
-        {
-		m_pXSecController->setX509Certificate( m_ouX509Certificate );
-		m_bInX509Certificate = false;
-        }
-        else if (aName == rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(NSTAG_DC))
-        			+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(":"))
-        			+rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(TAG_DATE)))
-	{
-		m_pXSecController->setDate( m_ouDate );
-        	m_bInDate = false;
-	}
-	/*
-	else if ( aName == rtl::OUString(RTL_ASCII_USTRINGPARAM(TAG_TIME)) )
-	{
-		m_pXSecController->setTime( m_ouTime );
-        	m_bInTime = false;
-	}
-	*/
+		*/
 
-	if (m_xNextHandler.is())
-	{
-		m_xNextHandler->endElement(aName);
+		if (m_xNextHandler.is())
+		{
+			m_xNextHandler->endElement(aName);
+		}
+	}
+	catch (cssu::Exception& )
+	{//getCaughtException MUST be the first line in the catch block
+        cssu::Any exc =  cppu::getCaughtException();
+        throw cssxs::SAXException(
+			rtl::OUString(RTL_CONSTASCII_USTRINGPARAM(
+                              "xmlsecurity: Exception in XSecParser::endElement")),
+            0, exc);
+	}
+	catch (...)
+	{
+		throw cssxs::SAXException(
+			rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("xmlsecurity: unexpected exception in XSecParser::endElement")), 0,
+			cssu::Any());
 	}
 }
 	
--- openoffice.org-2.0.2/xmlsecurity/source/helper/xsecsign.cxx	2005-09-09 19:24:01.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/helper/xsecsign.cxx	2006-04-07 13:57:34.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: xsecsign.cxx,v $
  *
- *  $Revision: 1.7 $
+ *  $Revision: 1.8 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:24:01 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:57:34 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -254,16 +254,18 @@
 void XSecController::setX509Certificate(
 	sal_Int32 nSecurityId,
 	const rtl::OUString& ouX509IssuerName,
-	const rtl::OUString& ouX509SerialNumber)
+	const rtl::OUString& ouX509SerialNumber,
+	const rtl::OUString& ouX509Cert)
 {
-	setX509Certificate(nSecurityId, -1, ouX509IssuerName, ouX509SerialNumber);
+	setX509Certificate(nSecurityId, -1, ouX509IssuerName, ouX509SerialNumber, ouX509Cert);
 }
 
 void XSecController::setX509Certificate(
 	sal_Int32 nSecurityId,
 	const sal_Int32	nSecurityEnvironmentIndex,
 	const rtl::OUString& ouX509IssuerName,
-	const rtl::OUString& ouX509SerialNumber)
+	const rtl::OUString& ouX509SerialNumber,
+	const rtl::OUString& ouX509Cert)
 {
 	int index = findSignatureInfor( nSecurityId );
 
@@ -273,6 +275,7 @@
 		isi.signatureInfor.nSecurityEnvironmentIndex = nSecurityEnvironmentIndex;
 		isi.signatureInfor.ouX509IssuerName = ouX509IssuerName;
 		isi.signatureInfor.ouX509SerialNumber = ouX509SerialNumber;
+		isi.signatureInfor.ouX509Certificate = ouX509Cert;
 		m_vInternalSignatureInformations.push_back( isi );
 	}
 	else
@@ -281,6 +284,7 @@
 			= m_vInternalSignatureInformations[index].signatureInfor;
 		si.ouX509IssuerName = ouX509IssuerName;
 		si.ouX509SerialNumber = ouX509SerialNumber;
+		si.ouX509Certificate = ouX509Cert;
 		si.nSecurityEnvironmentIndex = nSecurityEnvironmentIndex;
 	}
 }
--- openoffice.org-2.0.2/xmlsecurity/source/xmlsec/errorcallback.cxx	2005-11-11 10:19:25.000000000 +0100
+++ openoffice.org-2.0.3/xmlsecurity/source/xmlsec/errorcallback.cxx	2006-04-07 13:57:57.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: errorcallback.cxx,v $
  *
- *  $Revision: 1.5 $
+ *  $Revision: 1.6 $
  *
- *  last change: $Author: rt $ $Date: 2005/11/11 09:19:25 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:57:57 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -159,6 +159,13 @@
 		int reason,
 		const char *msg)
 {
+#if OSL_DEBUG_LEVEL > 1
+    const char * afunc = func ? func : "";
+    const char * errObj = errorObject ? errorObject : "";
+    const char * errSub = errorSubject ? errorSubject : "";
+    const char * amsg = msg ? msg : "";
+	fprintf(stdout, "xmlsec error: %s, %s,  %s, %i %s  \n", afunc, errObj, errSub, reason, amsg);
+#endif
     //ToDo write log message
 // 	if (g_xErrorRecorder.is() && !g_bErrorRecorded)
 // 	{
--- openoffice.org-2.0.2/xmlsecurity/inc/xmlsecurity/sigstruct.hxx	2005-09-09 19:07:57.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/inc/xmlsecurity/sigstruct.hxx	2006-04-07 13:55:40.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: sigstruct.hxx,v $
  *
- *  $Revision: 1.7 $
+ *  $Revision: 1.8 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:07:57 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:55:40 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -84,24 +84,30 @@
 
 struct SignatureInformation
 {
-	sal_Int32                       nSecurityId;
-	sal_Int32			nSecurityEnvironmentIndex;
-	
-	//sal_Int32			nStatus;
+	sal_Int32 nSecurityId;
+	sal_Int32 nSecurityEnvironmentIndex;
 	::com::sun::star::xml::crypto::SecurityOperationStatus nStatus;
-	
 	SignatureReferenceInformations  vSignatureReferenceInfors;
-	rtl::OUString                   ouX509IssuerName;
-	rtl::OUString                   ouX509SerialNumber;
-	rtl::OUString                   ouX509Certificate;
-	rtl::OUString                   ouSignatureValue;
-	
-	//rtl::OUString                   ouDate;
-	//rtl::OUString                   ouTime;
+	rtl::OUString ouX509IssuerName;
+	rtl::OUString ouX509SerialNumber;
+	rtl::OUString ouX509Certificate;
+	rtl::OUString ouSignatureValue;
 	::com::sun::star::util::DateTime stDateTime;
-	
-	rtl::OUString                   ouSignatureId;
-	rtl::OUString                   ouPropertyId;
+
+	//We also keep the date and time as string. This is done when this
+	//structure is created as a result of a XML signature being read.
+	//When then a signature is added or another removed, then the original
+	//XML signatures are written again (unless they have been removed).
+	//If the date time string is converted into the DateTime structure
+	//then information can be lost because it only holds a fractional
+	//of a second with a accuracy of one hundredth of second. 
+	//If the string contains
+	//milli seconds (because the document was created by an application other than OOo)
+	//and the converted time is written back, then the string looks different
+	//and the signature is broken.	
+	rtl::OUString ouDateTime;
+	rtl::OUString ouSignatureId;
+	rtl::OUString ouPropertyId;
 
     SignatureInformation( sal_Int32 nId )
 	{
--- openoffice.org-2.0.2/xmlsecurity/inc/xmlsecurity/xmlsignaturehelper.hxx	2005-09-09 19:08:43.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/inc/xmlsecurity/xmlsignaturehelper.hxx	2006-04-07 13:55:54.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: xmlsignaturehelper.hxx,v $
  *
- *  $Revision: 1.9 $
+ *  $Revision: 1.10 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:08:43 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:55:54 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -172,8 +172,30 @@
     void        StartMission();
     void        EndMission();
     sal_Int32   GetNewSecurityId();
-    void	    SetX509Certificate( sal_Int32 nSecurityId, const rtl::OUString& ouX509IssuerName, const rtl::OUString& ouX509SerialNumber);
-    void		SetX509Certificate( sal_Int32 nSecurityId, sal_Int32 nSecurityEnvironmentIndex,	const rtl::OUString& ouX509IssuerName,	const rtl::OUString& ouX509SerialNumber);
+    /** sets data that describes the certificate.
+
+        It is absolutely necessary that the parameter ouX509IssuerName is set. It contains
+        the base64 encoded certificate, which is DER encoded. The XMLSec needs it to find
+        the private key. Although issuer name and certificate should be sufficient to identify
+        the certificate the implementation in XMLSec is broken, both for Windows and mozilla.
+        The reason is that they use functions to find the certificate which take as parameter
+        the DER encoded ASN.1 issuer name. The issuer name is a DName, where most attributes
+        are of type DirectoryName, which is a choice of 5 string types. This information is
+        not contained in the issuer string and while it is converted to the ASN.1 name the
+        conversion function must assume a particular type, which is often wrong. For example,
+        the Windows function CertStrToName will use a T.61 string if the string does not contain
+        special characters. So if the certificate uses simple characters but encodes the
+        issuer attributes in Utf8, then CertStrToName will use T.61. The resulting DER encoded
+        ASN.1 name now contains different bytes which indicate the string type. The functions
+        for finding the certificate apparently use memcmp - hence they fail to find the
+        certificate.
+     */
+    void SetX509Certificate(sal_Int32 nSecurityId, const rtl::OUString& ouX509IssuerName, 
+		const rtl::OUString& ouX509SerialNumber, const rtl::OUString& ouX509Cert);
+     
+    void SetX509Certificate(sal_Int32 nSecurityId, sal_Int32 nSecurityEnvironmentIndex,	
+		const rtl::OUString& ouX509IssuerName,	const rtl::OUString& ouX509SerialNumber,
+		const rtl::OUString& ouX509Cert);
     void	    SetDateTime( sal_Int32 nSecurityId, const Date& rDate, const Time& rTime );
 
     void        AddForSigning( sal_Int32 securityId, const rtl::OUString& uri, const rtl::OUString& objectURL, sal_Bool bBinary );
